stages:          # List of stages for jobs, and their order of execution
    - s1
    - s2
    - s3
    - s4

default:
    image: alpine:latest

.jmodel: &model
    script:
        - echo begin $CI_JOB_NAME
        - sleep 5
        - echo end $CI_JOB_NAME
j1:
    stage: s1
    needs: []
    <<: *model

j2:
    stage: s1
    needs: []
    script:
        - sleep 20
        - echo $CI_JOB_NAME

j3:
    stage: s1
    needs: []
    script:
        - sleep 3
        - echo $CI_JOB_NAME

j4:
    stage: s2
    needs: [j1, j2]
    <<: *model

j5:
    stage: s2
    needs: [j3]
    <<: *model

j6:
    stage: s3
    needs: [j4]
    <<: *model

j7:
    stage: s3
    needs: [j5]
    <<: *model

j8:
    stage: s4
    needs: [j1]
    <<: *model

j9:
    stage: s4
    needs: [j6, j7]
    <<: *model

j10:
    stage: s4
    needs: [j5]
    <<: *model